Attribute VB_Name = "SHBrowseForFolder"

Option Explicit

Const WM_USER As Integer = &H400
Const MAX_PATH As Integer = 260


'Public Type RECT
'        Left As Long
'        Top As Long
'        Right As Long
'        Bottom As Long
'End Type

'Public Declare Function GetClientRect _
'  Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Public Declare Function GetSystemMetrics _
  Lib "user32" (ByVal nIndex As Long) As Long
Public Const SM_CXSCREEN As Long = 0
Public Const SM_CYSCREEN As Long = 1

Public Declare Function SetWindowPos _
  Lib "user32" (ByVal hwnd As Long, _
  ByVal hWndInsertAfter As Long, _
  ByVal x As Long, ByVal y As Long, _
  ByVal cx As Long, ByVal cy As Long, _
  ByVal wFlags As Long) As Long
Public Const SWP_NOSIZE As Long = &H1
Public Const SWP_NOZORDER As Long = &H4



' Prototypes pour appel de SHBrowseForFolder
Public Type SHBROWSFOLDERSTRUCT
        hwnd As Long
        pidlRoot As Long
        pszDisplayName As String
        pszTitle As String
        ulFlags As Integer
        lpfn As Long
        lParam As Long
        iImage As Integer
End Type

' Browsing for directory.
Const BIF_RETURNONLYFSDIRS As Integer = 1 ' For finding a folder to start document searching
Const BIF_DONTGOBELOWDOMAIN As Integer = 2  ' For starting the Find Computer
Const BIF_STATUSTEXT As Integer = 4
Const BIF_RETURNFSANCESTORS As Integer = 8
Const BIF_EDITBOX As Integer = &H10
Const BIF_VALIDATE As Integer = &H20

Const BIF_BROWSEFORCOMPUTER As Integer = &H1000 ' Browsing for Computers
Const BIF_BROWSEFORPRINTER As Integer = &H2000  ' Browsing for Printers
Const BIF_BROWSEINCLUDEFILES As Integer = &H4000 ' Browsing for Everything

' message from browser
Const BFFM_INITIALIZED As Integer = 1
Const BFFM_SELCHANGED As Integer = 2
Const BFFM_VALIDATEFAILEDA As Integer = 3 ' lParam:szPath ret:1(cont),0(EndDialog)
Const BFFM_VALIDATEFAILEDW As Integer = 4 ' lParam:wzPath ret:1(cont),0(EndDialog)

' messages to browser
Const BFFM_SETSTATUSTEXTA As Integer = WM_USER + 100
Const BFFM_ENABLEOK As Integer = WM_USER + 101
Const BFFM_SETSELECTIONA As Integer = WM_USER + 102
Const BFFM_SETSELECTIONW As Integer = WM_USER + 103
Const BFFM_SETSTATUSTEXTW As Integer = WM_USER + 104


Public Declare Function SHBrowseForFolder _
  Lib "shell32.dll" Alias "SHBrowseForFolderA" _
  (lpBrowseFolder As SHBROWSFOLDERSTRUCT) As Long


Public Declare Function SHGetPathFromIDList _
  Lib "shell32.dll" Alias "SHGetPathFromIDListA" _
  (ByVal pidl As Long, ByVal szPath As String) As Long

Public Type StringParm
  lgr As Long
  string As String
  center As Boolean
End Type


' **** la fonction permettant de choisir un rpertoire
'Dim selected As String
'selected = SelectFolder( _
'  "c:\DHR2000", "I like browsing for folders!" _
'  , False, True)
'MsgBox "Thank you for selecting the directory" & vbCr & selected


Public Function SelectFolder( _
    hwndOwner As Long, _
    InitialDir As String, _
    title As String, _
    allowFileSelection As Boolean, _
    centerIt As Boolean) As String
Dim browse As SHBROWSFOLDERSTRUCT
Dim dispName As String
Dim dispTitle As String
Dim res As Long, l As Long

'Dim s As String

Dim param As StringParm
param.string = InitialDir
param.lgr = Len(param.string)
param.center = centerIt

dispName = Space(MAX_PATH + 1)
dispTitle = title
browse.hwnd = hwndOwner
browse.pidlRoot = 0
browse.pszDisplayName = dispName
browse.pszTitle = dispTitle
If allowFileSelection Then
  browse.ulFlags = BIF_RETURNONLYFSDIRS Or BIF_BROWSEINCLUDEFILES
Else
  browse.ulFlags = BIF_RETURNONLYFSDIRS
End If
browse.lpfn = FnPtrToLong(AddressOf BrowseCallBackProc)
browse.lParam = VarPtr(param)
browse.iImage = 0
res = SHBrowseForFolder(browse)

dispTitle = Space(MAX_PATH + 1)
Call SHGetPathFromIDList(res, dispTitle)

'suppression de tout ce qui suit le '\0'
For l = 1 To Len(dispTitle)
  If Asc(Mid(dispTitle, l, 1)) = 0 Then
    Exit For
  End If
Next l
If l <= Len(dispTitle) Then dispTitle = Left(dispTitle, l - 1)

SelectFolder = dispTitle

End Function


' la call back est utilise pour fixer le rpertoire de dpart
Public Function BrowseCallBackProc _
  (ByVal hwnd As Long, ByVal uMsg As Integer, _
  ByVal lParam As Long, param As StringParm) _
  As Integer
'Debug.Print "BrowseCallBackProc(" & uMsg & ")"

If uMsg = BFFM_INITIALIZED Then
'  Debug.Print "BrowseCallBackProc(): set initial folder"
  Dim InitialDir As Long, sLoc As String
  Dim res() As Byte
  StringToSzPtr param.string, param.lgr, res

  sLoc = hexaDump(VarPtr(res(1)), param.lgr + 1)
'  Debug.Print sLoc

  Call SendMessage(hwnd, BFFM_SETSELECTIONA, 1, VarPtr(res(1)))
  If param.center Then
    Dim rc As RECT, rcFP As RECT
    Call GetClientRect(hwnd, rc)
'    Call SetWindowPos(hwnd, 0, _
'      (GetSystemMetrics(SM_CXSCREEN) - rc.Right + rc.Left) / 2, _
'      (GetSystemMetrics(SM_CYSCREEN) - rc.Bottom + rc.Top) / 2, _
'      0, 0, SWP_NOSIZE Or SWP_NOZORDER)
' maintenant on centre par rapport a la feuille principale et non pas
' par rapport a l'ecran. C'est utile en cas d'affichage sur double ecran
    Call GetWindowRect(PDFmerger.hwnd, rcFP)
    Call SetWindowPos(hwnd, 0, _
      (rcFP.Left + rcFP.Right - rc.Right + rc.Left) / 2, _
      (rcFP.Top + rcFP.Bottom - rc.Bottom + rc.Top) / 2, _
      0, 0, SWP_NOSIZE Or SWP_NOZORDER)
  End If
End If

BrowseCallBackProc = 0
End Function


