Attribute VB_Name = "Conversions"

Option Explicit


'----------------------------------------------------------
' suppression des caractres '\0' en fin de chane
Public Function stripNullChars(ByRef s As String) As String
Dim sLoc As String
sLoc = s & vbNullChar ' s'assurer d'un '\0' final
stripNullChars = Left$(sLoc, InStr(sLoc, vbNullChar) - 1)
End Function


'-----------------------------------------
' rend un chane "C" a partir d'une string
Public Sub StringToSzPtr(s As String, _
  ByVal cnt As Long, res() As Byte)
Dim of7 As Long, sLoc As String

ReDim res(1 To cnt + 1) As Byte

For of7 = 1 To cnt
  sLoc = Mid(s, of7, 1)
  memcpy VarPtr(res(of7)), StrPtr(sLoc), 1
Next of7
res(cnt + 1) = 0

End Sub


'--------------------------------
' retourne un dump hexa en string
' exemple :
'Dim I As Integer
'I = &H3697
'l = &H36927814
's = "692781439250"
'Debug.Print "I: " & hexaDump(VarPtr(I), LenB(I))
'Debug.Print "L: " & hexaDump(VarPtr(l), LenB(l))
'Debug.Print "s: " & hexaDump(StrPtr(s), LenB(s))

Public Function hexaDump(ByVal adrs As Long, ByVal cnt As Long) As String
Dim b As Byte, of7 As Long
Dim res As String

If cnt <= 0 Then hexaDump = "": Exit Function
res = "&H" & Hex(adrs) & ": "
For of7 = 0 To (cnt - 1)
  memcpy VarPtr(b), adrs + of7, 1
  If (b And &HF0) = 0 Then res = res & "0"
  res = res & Hex(b) & " "
Next of7
hexaDump = Left(res, Len(res) - 1)
End Function



'----------------------------------------------------
' fonction bidon pour pallier les contraintes
' de l'operateur AddressOf  qui ne peut se situer que
' dans les arguments d'une fonction
' au lieu d'ecrire :
' toto = AdressOf(Nom_De_Fonction)
' on doit ecrire :
' toto = FnPtrToLong(AdressOf Nom_De_Fonction)
' exemple
' browse.lpfn = FnPtrToLong(AddressOf BrowseCallBackProc)

Function FnPtrToLong(ByVal lngFnPtr As Long) As Long
   FnPtrToLong = lngFnPtr
End Function


'----------------------------------------------------
' cette fonction dit si tous les caracteres d'une chaine
' sont des chiffres ASCII
' une chaine vide est considre comme non valide
' les espaces sont aussi consideres comme invalides
Public Function IsNaturalNumber(s As String) As Boolean
Dim i As Long, j As Long

If Len(s) = 0 Then IsNaturalNumber = False: Exit Function
For i = 1 To Len(s)
  j = Asc(Mid(s, i, 1))
  If (j < 48) Or (j > 57) Then ' 48 = '0' , 57 = '9'
    IsNaturalNumber = False
    Exit Function
  End If
Next i
IsNaturalNumber = True
End Function


'
' ***************************************************
' * Fonction indiquant si le caractere d'une chaine *
' * est un delimiteur dans une liste specifie       *
' ***************************************************
' L'astuce consiste a rechercher le caractere dans la
' chaine des separateurs, au lieu du contraire
Public Function IsItSeparator( _
  s As String, lWhere As Long, sSeparators As String) _
  As Boolean
Dim sChar As String, sLoc As String
If (Len(s) >= lWhere) Then
  sChar = Mid(s, lWhere, 1)
  sLoc = sSeparators & sChar ' assurer la trouvaille
  IsItSeparator = IIf(InStr(1, sLoc, sChar, vbBinaryCompare) > Len(sSeparators), False, True)
Else
  IsItSeparator = False
End If
End Function


'
' *******************************************************
' * Fonction recherchant un delimiteur, parmi une liste *
' * donnee, dans une chaine specifiee                   *
' *******************************************************
' La valeur de retour est l'indice, dans la chaine specifiee,
' du 1er delimiteur trouve (0 si non trouve)
Public Function LookUpForSeparator( _
  sTringToLook As String, sSeparators As String, _
  lIndStart As Long) _
  As Long
Dim lIxCur As Long, lStop As Long, lFound As Long
Dim sChar As String, sLoc As String

lStop = Len(sTringToLook)
If (lStop = 0) _
Or (lIndStart > lStop) _
Or (Len(sSeparators) = 0) _
Then
  LookUpForSeparator = 0 ' dans ces cas, on ne risque pas de trouver !
  Exit Function
End If

' meme astuce que dans la fonction IsItSeparator()
' au lieu de chercher un delimiteur dans la chaine, on recherche
' chaque caractere dans la chaine des delimiteurs
For lIxCur = lIndStart To lStop
  sChar = Mid(sTringToLook, lIxCur, 1)
  lFound = InStr(1, sSeparators, sChar, vbBinaryCompare)
  If (lFound > 0) Then
    LookUpForSeparator = lIxCur
    Exit Function
  End If
Next lIxCur
LookUpForSeparator = 0
End Function


'
' *******************************************************
' * Fonction supprimant tous les delimiteurs a la fin   *
' * d'une chaine                                        *
' *******************************************************
' La valeur de retour est l'indice, dans la chaine specifiee,
' du 1er non-delimiteur trouve (0 si non trouve)
Public Function TrimEndingSeparators( _
  sTringToLook As String, sSeparators As String) _
   As String
Dim lIxDeb As Long, lFound As Long

lFound = Len(sTringToLook)

For lIxDeb = Len(sTringToLook) To 1 Step -1
  If IsItSeparator(sTringToLook, lIxDeb, sSeparators) Then
    lFound = lFound - 1
  Else
    Exit For
  End If
Next lIxDeb
TrimEndingSeparators = Left(sTringToLook, lFound)
End Function

'
' *******************************************************
' * Fonction supprimant tous les delimiteurs au debut   *
' * et a la fin d'une chaine                            *
' *******************************************************

Public Function TrimSeparators( _
  sTringToLook As String, sSeparators As String) _
   As String
Dim lWork As Long

' localiser et supprimer les separateurs initiaux et finals
lWork = JumpOverSeparators(sTringToLook, sSeparators, 1)
If (lWork = 0) Then
' ligne sans information utile (i.e. ne comportant que des separateurs)
  TrimSeparators = ""
Else
'  sWork = Mid(sTringToLook, lWork)
  TrimSeparators = _
    TrimEndingSeparators(Mid(sTringToLook, lWork), sSeparators)
End If
End Function

' suppression des fins de lignes de debut et de fin
Public Function TrimEOLSeparators(sTringToLook As String) As String
TrimEOLSeparators = TrimSeparators(sTringToLook, vbCr & vbLf)
End Function

' suppression des espaces (au sens large) de debut et de fin
Public Function TrimSpaceSeparators(sTringToLook As String) As String
TrimSpaceSeparators = TrimSeparators(sTringToLook, " " & vbCr & vbLf)
End Function


'
' *******************************************************
' * Fonction supprimant tout ce qui suit un delimiteur  *
' * (y compris le delimiteur) choisi dans une liste     *
' *******************************************************
' La valeur de retour est l'indice, dans la chaine specifiee,
' du 1er delimiteur trouve (0 si non trouve)
Public Function RTrimAfterSeparator( _
  sTringToLook As String, sSeparators As String, _
  lIndStart As Long) _
   As String
Dim lFound As Long

lFound = LookUpForSeparator(sTringToLook, sSeparators, lIndStart)
If (lFound = 0) Then ' pas de delimiteur dans la chaine
    RTrimAfterSeparator = sTringToLook
Else
    RTrimAfterSeparator = Left(sTringToLook, (lFound - 1))
End If
End Function

'
' *******************************************************
' * Fonction recherchant le premier caractere d'une     *
' * chaine ne figurant pas dans une liste specifiee     *
' *******************************************************
' La valeur de retour est l'indice, dans la chaine specifiee,
' du 1er qui ne soit pas un delimiteur
' (0 si la chaine ne contient que des delimiteurs)
Public Function JumpOverSeparators( _
  sTringToLook As String, sSeparators As String, _
  lIndStart As Long) _
  As Long
Dim lIxCur As Long, lStop As Long, lFound As Long
Dim sChar As String

lStop = Len(sTringToLook)
If (lStop = 0) _
Or (lIndStart > lStop) _
Or (Len(sSeparators) = 0) _
Then
  JumpOverSeparators = 0 ' dans ces cas, on ne risque pas de trouver !
  Exit Function
End If

' meme astuce que dans la fonction IsItSeparator()
' au lieu de chercher un delimiteur dans la chaine d'entree,
' on recherche chaque caractere d'entree dans la chaine des delimiteurs
For lIxCur = lIndStart To lStop
  sChar = Mid(sTringToLook, lIxCur, 1)
  lFound = InStr(1, sSeparators, sChar, vbBinaryCompare)
  If (lFound = 0) Then
    JumpOverSeparators = lIxCur
    Exit Function
  End If
Next lIxCur
JumpOverSeparators = 0 ' la chaine ne contient que des separateurs
End Function

' Cette fonction fait comme Val, mais en considerant
' les espaces comme des separateurs de nombres
' mais on supprime ceux du debut et ceux de fin
Public Function GetNaturalNumberFromString( _
  s As String, ByRef nbDigits As Integer) As Long
Dim sLoc As String, realValue As Double, sep As String
Dim lPos As Long

sep = " "
sLoc = Trim(s) & sep ' s'assurer qu'on trouvera le separateur
lPos = InStr(1, sLoc, sep, vbBinaryCompare)
nbDigits = (lPos - 1)
If (nbDigits > 0) Then
  sLoc = Left(sLoc, nbDigits)
  If IsNaturalNumber(sLoc) Then
    If Len(sLoc) < 11 Then
      realValue = Val(sLoc) ' verification de debordement
      If realValue < 2147483646.999 Then
        GetNaturalNumberFromString = Val(sLoc)
      Else
        nbDigits = 0
        GetNaturalNumberFromString = 0
      End If
    Else
      nbDigits = 0
      GetNaturalNumberFromString = 0
    End If
  Else
    nbDigits = 0
    GetNaturalNumberFromString = 0
  End If
Else
  nbDigits = 0
  GetNaturalNumberFromString = 0
End If
End Function

'
' La fonction GetNaturalValueFromString() fait comme GetNaturalNumberFromString(),
' mais en ignorant les eventuels espaces et Cr/LF de debut
' elle rend une valeur 0 et nbDigits = 0 si la chaine ne contient pas de chiffre
Public Function GetNaturalValueFromString( _
  s As String, ByRef nbDigits As Integer) As Long
Dim sLoc As String, lPos As Long

lPos = JumpOverSeparators(s, vbCr & vbLf & " ", 1)
If (lPos = 0) Then 'La ligne ne contient pas de valeur : on rend 0 et erreur
  nbDigits = 0
  GetNaturalValueFromString = 0
  Exit Function
End If

'sLoc = Mid(s, lPos) ' PAS SI SIMPLE !
sLoc = RTrimAfterSeparator(Mid(s, lPos), vbCr & vbLf & " ", 1)
GetNaturalValueFromString = _
  GetNaturalNumberFromString(sLoc, nbDigits)
End Function


