Attribute VB_Name = "FileModule"

Option Explicit


Public Function SetDefaultTmpDirectory() As String
Dim sTmpDirectory As String
sTmpDirectory = Trim(GetTemporaryDirectory()) ' repertoire temporaire "systeme"
If (Right(sTmpDirectory, 1) <> "\") Then sTmpDirectory = sTmpDirectory & "\"
On Error Resume Next
InitRegistry
Call SetRegistry("MergeTmpDir", sTmpDirectory)
CloseRegistry
Err.Clear
SetDefaultTmpDirectory = sTmpDirectory
End Function


' Obtenir le chemin du repertoire pour les fichiers temporaires
' rend une chaine vide si on n'a pas pu l'obtenir
Public Function GetMyTmpDirectory() As String
Dim sTmpDir As String, sTmpDir2 As String, sOldDir As String

On Error Resume Next ' pour gerer les erreurs et les "cancel"
sTmpDir = Trim(GetTemporaryDirectory()) ' repertoire temporaire "systeme"
If (Right(sTmpDir, 1) <> "\") Then sTmpDir = sTmpDir & "\"
sTmpDir2 = ""
' Voir si un repertoire de fichiers temporaires est deja defini, afin de le
' proposer au lieu du repertoire "systeme"
InitRegistry
Call ReadOrSetDefaultReg("MergeTmpDir", sTmpDir2, sTmpDir)
sTmpDir2 = Trim(sTmpDir2)
' verif de l'existence du repertoire lu dans le registry
If (sTmpDir2 = "") Then sTmpDir2 = sTmpDir
If (Right(sTmpDir2, 1) <> "\") Then sTmpDir2 = sTmpDir2 & "\"

' verif de possibilite d'aller dans le repertoire finalement choisi
sOldDir = CurDir()
Err.Clear
ChDir sTmpDir2
ChDir sOldDir
If (Err.Number <> 0) Then sTmpDir2 = ""
Err.Clear

Call SetRegistry("MergeTmpDir", sTmpDir2)
CloseRegistry
Err.Clear
GetMyTmpDirectory = sTmpDir2
End Function

' Obtenir le chemin du repertoire pour les fichiers temporaires
' rend une chaine vide si on n'a pas pu l'obtenir
Public Function GetMeSomeTmpDirectory() As String
Dim sTmpDir As String
sTmpDir = GetMyTmpDirectory() ' eventuellement chaine vide
If (sTmpDir = "") Then sTmpDir = AskForTmpDirectory()
GetMeSomeTmpDirectory = sTmpDir
End Function

' Choix du repertoire pour les fichiers temporaires
' Rend toujours un repertoire
Public Function AskForTmpDirectory() As String
Dim sTmpDir As String, sTmpDir2 As String, sOldDir As String, s As String

On Error Resume Next ' pour gerer les erreurs et les "cancel"
sTmpDir2 = GetMyTmpDirectory() ' eventuellement chaine vide
If (sTmpDir2 = "") Then sTmpDir2 = Trim(GetTemporaryDirectory())
Err.Clear

' demander le repertoire des fichiers temporaires
s = ""
s = SelectFolder(PDFmerger.hwnd, sTmpDir2, _
  "Portable document merger: Choose FOLDER FOR TEMPORARY FILES", False, True)
sTmpDir = Trim(s) ' supprimer les espaces de debut et fin
If (sTmpDir = "") Then sTmpDir = GetMyTmpDirectory()
' NB : ainsi, on rend un repertoire temporaire, dans tous les cas
If (sTmpDir = "") Then sTmpDir = Trim(GetTemporaryDirectory())
If (Right(sTmpDir, 1) <> "\") Then sTmpDir = sTmpDir & "\"
InitRegistry
Call SetRegistry("MergeTmpDir", sTmpDir)
CloseRegistry
Err.Clear
AskForTmpDirectory = sTmpDir
End Function

'
' Effacer un fichier
' Si on n'y arrive pas, lui metttre une longueur nulle
Public Sub KillOrAtLeastErase(sFileName As String)
On Error Resume Next
SetAttr sFileName, vbNormal
Kill sFileName
If FileExists(sFileName) Then
  EraseFile sFileName
End If
Err.Clear
End Sub

'
' rendre un fichier (existant) de longueur nulle
' On ne fait que tester
Public Function EraseFile(sFileName As String) _
  As Boolean
Dim lpSecAttr As SECURITY_ATTRIBUTES
Dim l_hFile As Long ', lErrorCode As Long

With lpSecAttr
  .nLength = LenB(lpSecAttr) ' 12
  .lpSecurityDescriptor = 0&
  .bInheritHandle = False
End With

' CreateFile ne modifie pas la valeur de retour en cas d'erreur
' Il faut donc l'initialiser a HFILE_ERROR
l_hFile = HFILE_ERROR
On Error Resume Next
l_hFile = CreateFile( _
  lpFileName:=sFileName, _
  dwDesiredAccess:=GENERIC_WRITE, _
  dwShareMode:=FILE_SHARE_READ, _
  lpSecurityAttributes:=lpSecAttr, _
  dwCreationDisposition:=TRUNCATE_EXISTING, _
  dwFlagsAndAttributes:=FILE_ATTRIBUTE_NORMAL, _
  hTemplateFile:=0)

If ((l_hFile = HFILE_ERROR) Or (Err.Number <> 0)) Then
'  lErrorCode = GetLastError()
  Err.Clear
  EraseFile = False
Else
  EraseFile = True
End If
Call CloseHandle(l_hFile)
End Function

'
' Tester si un fichier existe, sans le creer s'il n'existe pas
' On ne fait que tester
Public Function FileExists(sFileName As String) _
  As Boolean
Dim lpSecAttr As SECURITY_ATTRIBUTES
Dim l_hFile As Long ', lErrorCode As Long

With lpSecAttr
  .nLength = LenB(lpSecAttr) ' 12
  .lpSecurityDescriptor = 0&
  .bInheritHandle = False
End With

' CreateFile ne modifie pas la valeur de retour en cas d'erreur
' Il faut donc l'initialiser a HFILE_ERROR
l_hFile = HFILE_ERROR
On Error Resume Next
l_hFile = CreateFile( _
  lpFileName:=sFileName, _
  dwDesiredAccess:=GENERIC_READ, _
  dwShareMode:=FILE_SHARE_READ, _
  lpSecurityAttributes:=lpSecAttr, _
  dwCreationDisposition:=OPEN_EXISTING, _
  dwFlagsAndAttributes:=FILE_ATTRIBUTE_NORMAL, _
  hTemplateFile:=0)

If ((l_hFile = HFILE_ERROR) Or (Err.Number <> 0)) Then
'  lErrorCode = GetLastError()
  Err.Clear
  FileExists = False
Else
  FileExists = True
End If
Call CloseHandle(l_hFile)
End Function


'
' * Forcer la taille d'un fichier (indispensable en Binary)
' *** Exemple d'utilisation :
' *** SetTheEndOfTheFile "C:\VisualB\Patcher\A-PDF\Copie de 3739.pdf", 16
' *** Exit Sub
Public Function SetTheEndOfTheFile( _
  sFileName As String, lNxtLgFil As Long) _
  As Boolean
Dim lpSecAttr As SECURITY_ATTRIBUTES
Dim l_hFile As Long, lgr As Long, lErrorCode As Long

#If boLogSetEOF Then
Dim s0 As String
s0 = "[SetTheEndOfTheFile]=>"
LogWindow.AddLogLine s0 & "Force the length of file:  " & _
  Chr$(34) & sFileName & Chr$(34) & "  to:" & CStr(lNxtLgFil)
#End If

With lpSecAttr
  .nLength = LenB(lpSecAttr) ' 12
  .lpSecurityDescriptor = 0&
  .bInheritHandle = False
End With

' CreateFile ne modifie pas la valeur de l_hFile en cas d'erreur
l_hFile = HFILE_ERROR
On Error Resume Next
l_hFile = CreateFile( _
  lpFileName:=sFileName, _
  dwDesiredAccess:=(GENERIC_READ Or GENERIC_WRITE), _
  dwShareMode:=FILE_SHARE_READ Or FILE_SHARE_WRITE, _
  lpSecurityAttributes:=lpSecAttr, _
  dwCreationDisposition:=OPEN_EXISTING, _
  dwFlagsAndAttributes:= _
    (FILE_ATTRIBUTE_NORMAL Or FILE_FLAG_RANDOM_ACCESS), _
  hTemplateFile:=0)

If ((l_hFile = HFILE_ERROR) Or (Err.Number <> 0)) Then
  lErrorCode = GetLastError()
#If boLogSetEOF Then
LogWindow.AddLogLine s0 & "Could not open file:  " & _
  Chr$(34) & sFileName & Chr$(34) & "  (Error: " & CStr(lErrorCode) & ")"
#End If
  SetTheEndOfTheFile = False
  Err.Clear
  Exit Function
End If

' se positionner a l'endroit ou on veut s'arreter
lgr = SetFilePointer(l_hFile, lNxtLgFil, 0&, FILE_BEGIN)
If ((lgr <> lNxtLgFil) Or (Err.Number <> 0)) Then
  l_hFile = GetLastError()
#If boLogSetEOF Then
LogWindow.AddLogLine s0 & "Could not 'seek' position:  " & _
  CStr(lNxtLgFil) & "  (Error: " & CStr(l_hFile) & ")"
#End If
  Call CloseHandle(l_hFile)
  SetTheEndOfTheFile = False
  Err.Clear
  Exit Function
End If

' c'est que ca se passe - la fin de fichier est forcee
' derriere l'octet sur lequel on est positionne
lgr = SetEndOfFile(l_hFile)
If (lgr = 0) Then
  l_hFile = GetLastError()
#If boLogSetEOF Then
LogWindow.AddLogLine s0 & "Could not set file length to:  " & _
  CStr(lNxtLgFil) & "  (Error: " & CStr(l_hFile) & ")"
#End If
  Call CloseHandle(l_hFile)
  SetTheEndOfTheFile = False
  Err.Clear
  Exit Function
End If

Call CloseHandle(l_hFile)
#If boLogSetEOF Then
LogWindow.AddLogLine s0 & "Length of file:  " & _
  Chr$(34) & sFileName & Chr$(34) & _
  "  successfully set to " & CStr(lNxtLgFil)
#End If

SetTheEndOfTheFile = True
End Function


Public Function ReadLineFromRandomFile( _
  ByVal fileNumber As Integer, _
  ByVal startPos As Long, _
  ByVal maxLineSize As Integer, _
  ByVal maxExtentCount As Integer, _
  lineString As String, _
  ByVal logTheOp As Boolean _
  ) As Long
Dim iExtentCount As Integer, lResultRead As Long
Dim sWork As String, lPosStart As Long, lActualPosStart As Long

If logTheOp Then
  Dim s0 As String
  s0 = "[ReadLineFromRandomFile]=>"
'  LogWindow.AddLogLine s0 & "fileNumber: " & fileNumber & _
'    " - startPos: " & startPos & " - maxLineSize: " & maxLineSize & _
'    " - maxExtentCount: " & maxExtentCount
End If

iExtentCount = 1
lResultRead = TryToReadLineFromRandomFile( _
  fileNumber:=fileNumber, _
  startPos:=startPos, _
  maxLineSize:=maxLineSize, _
  lineString:=lineString, _
  lActualReadPos:=lActualPosStart, _
  logTheOp:=logTheOp)
' Memoriser la position de depart (on suppose que ce sera OK)
ReadLineFromRandomFile = lActualPosStart
' si le buffer n'etait pas assez long, on lit la suite
lPosStart = lActualPosStart + Len(lineString)
Do While ((lResultRead = -2) And (iExtentCount < maxExtentCount))
  iExtentCount = (iExtentCount + 1)
  sWork = ""
  lResultRead = TryToReadLineFromRandomFile( _
    fileNumber:=fileNumber, _
    startPos:=lPosStart, _
    maxLineSize:=maxLineSize, _
    lineString:=sWork, _
    lActualReadPos:=lActualPosStart, _
    logTheOp:=logTheOp)
  If ((lResultRead = -2) Or (lResultRead > 0)) Then
' Dans ce cas, on ne change pas la valeur de retour de
' la fonction ReadLineFromRandomFile()
    lineString = lineString & sWork
    If (lResultRead > 0) Then
      Exit Do
    End If
    lPosStart = lActualPosStart + Len(sWork)
  Else
' (lResultRead < 0)  And (lResultRead <> -2)
    ReadLineFromRandomFile = lResultRead ' rendre la valeur de l'erreur
    Exit Do
  End If
Loop
' sortie OK ou en erreur ?
If (lResultRead <= 0) Then
  ReadLineFromRandomFile = lResultRead ' meme si lResultRead = -2
End If

If (logTheOp And (iExtentCount > 1)) Then
  If (lResultRead <> -2) Then
    LogWindow.AddLogLine s0 & _
      "*** Warning! *** Buffer size had to be increased from " & _
      maxLineSize & " to " & (maxLineSize * iExtentCount) & " *** Warning! <="
  Else
    LogWindow.AddLogLine s0 & _
      "***** WARNING!!! ***** Buffer size remained too small although I retried " & _
      iExtentCount & " times ***** WARNING!!! <="
  End If
End If
End Function

'
' lecture d'une ligne de texte dans un fichier deja ouvert en mode RANDOM
' a partir d'une POSITION donnee
' rend une string et la position effective de la chaine rendue
' dans le fichier (ATTENTION : 1 pour 1er octet)
' -1 si lecture au dela de fin de fichier,
' -2 si chaine trop courte (valeur a reserver strictement a ce cas)
' autre valeur < 0 pour les autres erreurs
' Meme en cas d'erreur, on ne ferme pas le fichier
Public Function TryToReadLineFromRandomFile( _
  ByVal fileNumber As Integer, _
  ByVal startPos As Long, _
  ByVal maxLineSize As Integer, _
  lineString As String, _
  ByRef lActualReadPos As Long, _
  ByVal logTheOp As Boolean _
  ) As Long
Dim fileSize As Long
Dim byteLine() As Byte, lgBf As Integer
Dim endOfLoop As Boolean, i As Long, j As Long, k As Long

'If logTheOp Then
'  Dim s0 As String
'  s0 = "[TryToReadLineFromRandomFile]=>"
'  LogWindow.AddLogLine s0 & "fileNumber: " & fileNumber & _
'    " - startPos: " & startPos & " - maxLineSize: " & maxLineSize
'End If

If _
  (fileNumber < 0) _
Or _
  (startPos < 0) _
Or _
  (maxLineSize < 1) _
Then
  lineString = ""
  lActualReadPos = -1
  TryToReadLineFromRandomFile = -3 ' invalid file number or start position
'  If logTheOp Then
'    LogWindow.AddLogLine s0 & "Result: " & TryToReadLineFromRandomFile & _
'      " =" & Chr$(34) & lineString & Chr$(34)
'  End If
  Exit Function
End If

On Error Resume Next ' pour pouvoir traiter en douceur les erreurs

' voir ce qu'on peut demander
fileSize = LOF(fileNumber)
If Err.Number <> 0 Then
  Err.Clear
  lineString = ""
  lActualReadPos = -1
  TryToReadLineFromRandomFile = -4 ' cannot get file size
'  If logTheOp Then
'    LogWindow.AddLogLine s0 & "Result: " & TryToReadLineFromRandomFile & _
'      " =" & Chr$(34) & lineString & Chr$(34)
'  End If
  Exit Function
End If

If ((startPos + maxLineSize - 1) <= fileSize) Then
  ReDim byteLine(1 To maxLineSize) As Byte
ElseIf (startPos <= fileSize) Then
  ReDim byteLine(1 To (fileSize - startPos + 1)) As Byte
Else ' startPos > fileSize
  lineString = ""
  lActualReadPos = -1
  TryToReadLineFromRandomFile = -1 ' read past end of file
'  If logTheOp Then
'    LogWindow.AddLogLine s0 & "Result: " & TryToReadLineFromRandomFile & _
'      " =" & Chr$(34) & lineString & Chr$(34)
'  End If
  Exit Function
End If
lgBf = UBound(byteLine) ' - LBound(byteLine) + 1

Err.Clear
Seek #fileNumber, startPos
If Err.Number <> 0 Then
  Err.Clear
  lineString = ""
  lActualReadPos = -1
  TryToReadLineFromRandomFile = -5 ' Seek error
'  If logTheOp Then
'    LogWindow.AddLogLine s0 & "Result: " & TryToReadLineFromRandomFile & _
'      " =" & Chr$(34) & lineString
'  End If
  Exit Function
End If

Get #fileNumber, , byteLine
If Err.Number <> 0 Then
  Err.Clear
  lineString = ""
  lActualReadPos = -1
  TryToReadLineFromRandomFile = -6 ' Read error
'  If logTheOp Then
'    LogWindow.AddLogLine s0 & "Result: " & TryToReadLineFromRandomFile & _
'      " =" & Chr$(34) & lineString & Chr$(34)
'  End If
  Exit Function
End If

' suppression des CR LF de debut de chaine
' cela permet de supprimer des lignes vides
' ou encore (pour PDFmerger) de tenir compte
' des variantes de formats de lignes (CR vs LF vs CR+LF)
i = 1   ' LBound(byteLine)
endOfLoop = False
Do While Not endOfLoop
  If (i <= lgBf) Then
    If _
    ( _
      (byteLine(i) = Asc(vbCr)) _
    Or _
    ( _
      byteLine(i)) = Asc(vbLf)) _
    Then
      i = (i + 1)
      If (i > lgBf) Then
        endOfLoop = True
      End If
    Else
      endOfLoop = True ' byteLine(i) <> vbCr or vbLf
    End If
  End If
Loop
'
If (i > lgBf) Then
' il n'y avait que des CR et/ou LF dans le buffer
  lineString = ""
  lActualReadPos = (fileSize + 1)
  TryToReadLineFromRandomFile = lActualReadPos
Else
' Il y a un non-EOL a l'indice 'i'
' limitation de la chaine au 1er CR ou LF qui suit le 1er car.
' C'est utile si on en rencontre 1 ...
  lActualReadPos = (startPos + i - 1)
  j = (i + 1)
  endOfLoop = (j > lgBf)
  Do While Not endOfLoop ' attention une condition AND ne marche pas !
    If (j <= lgBf) Then
      If _
      ( _
        (byteLine(j) <> Asc(vbCr)) _
      And _
      ( _
        byteLine(j)) <> Asc(vbLf)) _
      Then
        j = j + 1
        If (j > lgBf) Then
          endOfLoop = True
        End If
      Else
        endOfLoop = True ' ' byteLine(i) = vbCr or vbLf
      End If
    End If ' (j <= lgBf)
  Loop
'
  If (j > lgBf) Then
' Cela peut se produire pendant une lecture de TRAILER ou d'objet
' On rend la chaine pour permettre une concatenation
'    lineString = ByteArrayToString(byteLine, i, (lgBf - i + 1))
    lineString = ""
    For k = i To lgBf
      lineString = lineString & Chr(byteLine(k))
    Next k
    TryToReadLineFromRandomFile = -2 ' Requested buffer length too small
'    If (logTheOp) Then
'      LogWindow.AddLogLine s0 & "ERROR: BUFFER TOO SMALL" & _
'        " =" & Chr$(34) & lineString & Chr$(34)
'    End If
    Exit Function
  End If
' conversion du byte array en string (juste la partie utile)
'  lineString = ByteArrayToString(byteLine, i, (j - i))
  lineString = ""
  For k = i To (j - 1)
    lineString = lineString & Chr(byteLine(k))
  Next k
  TryToReadLineFromRandomFile = lActualReadPos
End If
'If logTheOp Then
'  LogWindow.AddLogLine s0 & "Result: " & TryToReadLineFromRandomFile & _
'      " =" & Chr$(34) & lineString & Chr$(34)
'End If
End Function

'
' lecture d'un certain nombre d'octets
' rend une string (vie si erreur) et le nombre d'octets effectivement
' lus dans le fichier (< 0 si erreur :
' -1 si lecture au dela de fin de fichier,
' autre valeur < 0 pour les autres erreurs)
' Meme en cas d'erreur, on ne ferme pas le fichier
Public Function ReadBytesFromRandomFile( _
  ByVal iFileNumber As Integer, _
  ByVal lStartPos As Long, _
  ByVal iCountToRead As Integer, _
  sLineString As String _
  ) As Integer
Dim lFileSize As Long
Dim byteLine() As Byte, indBf As Integer

If _
  (iFileNumber < 0) _
Or _
  (lStartPos < 0) _
Or _
  (iCountToRead < 1) _
Then
  sLineString = ""
  ReadBytesFromRandomFile = -3 ' invalid file number or start position
  Exit Function
End If

On Error Resume Next ' pour pouvoir traiter en douceur les erreurs

' voir ce qu'on peut demander
lFileSize = LOF(iFileNumber)
If Err.Number <> 0 Then
  Err.Clear
  sLineString = ""
  ReadBytesFromRandomFile = -4 ' cannot get file size
  Exit Function
End If

If ((lStartPos + iCountToRead - 1) <= lFileSize) Then
  ReDim byteLine(1 To iCountToRead) As Byte
ElseIf (lStartPos <= lFileSize) Then
  ReDim byteLine(1 To (lFileSize - lStartPos + 1)) As Byte
Else ' lStartPos > lFileSize
  sLineString = ""
  ReadBytesFromRandomFile = -1 ' read past end of file
  Exit Function
End If

Err.Clear
Seek #iFileNumber, lStartPos
If Err.Number <> 0 Then
  Err.Clear
  sLineString = ""
  ReadBytesFromRandomFile = -5 ' Seek error
  Exit Function
End If

Get #iFileNumber, , byteLine
If Err.Number <> 0 Then
  Err.Clear
  sLineString = ""
  ReadBytesFromRandomFile = -6 ' Read error
  Exit Function
End If

'iLgBf = UBound(byteLine) ' - LBound(byteLine) + 1
'sLineString = ByteArrayToString(byteLine, 1, iLgBf)
sLineString = ""
For indBf = LBound(byteLine) To UBound(byteLine)
  sLineString = sLineString & Chr(byteLine(indBf))
Next indBf
ReadBytesFromRandomFile = Len(sLineString)
End Function


' separe le nom et chemin d'accs d'un fichier
' donn par son pathname complet (rendu sans le '\' final)
Public Sub ExtractFileNameAndPath(fullName As String, _
  fName As String, fPath As String)
Dim sTemp As String, i As Long

sTemp = "\" & fullName   ' s'assurer qu'on trouvera un "\"
i = InStrRev(sTemp, "\") ' recherche a partir de la fin
If (i <= 1) Then
  fName = fullName
  fPath = ""
Else
  fName = Right(fullName, Len(sTemp) - i)
  fPath = Left(fullName, i - 2)
End If

End Sub


' separe l'extension du reste
' l'extension est rendue sans le "."
Public Sub GetFileNameExtension(fullName As String, _
  fName As String, fExt As String)
Dim sTemp As String, i As Long

sTemp = "." & fullName   ' s'assurer qu'on trouvera un "."
i = InStrRev(sTemp, ".") ' recherche a partir de la fin
If (i <= 1) Then
  fName = fullName
  fExt = ""
Else
  fExt = Right(fullName, (Len(sTemp) - i))
  fName = Left(fullName, (i - 2))
End If
End Sub


'
' Obtenir le nom du repertoire Windows des fichiers temporaires
Public Function GetTemporaryDirectory() As String
Dim sLocalTempDir As String, lTempLgr As Long
Dim sResult As String
Dim sfName As String, sfPath As String, sfExt As String

' Aller chercher le "temp" de Windows
sLocalTempDir = ""
lTempLgr = 0
lTempLgr = GetTempPath(lTempLgr, sLocalTempDir) ' obtenir la longueur necessaire
If (lTempLgr > 0) Then
  sLocalTempDir = Space$(lTempLgr + 3)
  lTempLgr = GetTempPath(lTempLgr, sLocalTempDir) ' obtenir la vraie valeur
End If
If (lTempLgr <= 0) Then
  GetTemporaryDirectory = ""
  Exit Function
End If
sLocalTempDir = Left(sLocalTempDir, lTempLgr)  ' enlever le '\0' final
GetTemporaryDirectory = GetActualLongFileName(sLocalTempDir)
End Function


' Obtenir un fichier temporaire
' si sTempDir = "" , on recherche le repertoire Windows des fichiers temporaires
' si sPrefix = "", on prend le prefixe par defaut "Pat"
' si sSuffix = "", on laisse le suffixe donne par Windows
Public Function GetTemporaryFileName( _
  sTempDir As String, sPrefix As String, sSuffix As String) As String
Dim sLocalPrefix As String ' , sLocalSuffix As String
Dim sLocalTempDir As String, lTempLgr As Long
Dim sResult As String, boFoundTempFile As Boolean, iNbLoops As Integer
Dim sfName As String, sfPath As String, sfExt As String
Dim sFormerTmpName As String

If (Len(sTempDir) = 0) Then
' Aller chercher le nom (long) du "temp" de Windows
  sLocalTempDir = GetTemporaryDirectory()
Else ' (Len(sTempDir) > 0)
' Obtenir le nom "long" du repertoire TEMP
  sLocalTempDir = GetActualLongFileName(sTempDir)
End If
If (sLocalTempDir = "") Then
  GetTemporaryFileName = ""
  Exit Function
End If

sLocalPrefix = IIf((Len(sPrefix) = 0), "PAT", sPrefix)

iNbLoops = 1000 ' prevention contre boucle infinie
sFormerTmpName = "" ' pour s'assurer de ne pas avoir toujours le meme nom
boFoundTempFile = False
Do While ((Not boFoundTempFile) And (iNbLoops > 0))
  iNbLoops = (iNbLoops - 1)
  sfName = Space$(MAX_PATH)
  If (GetTempFileName(sLocalTempDir, sLocalPrefix, 0, sfName) = 0) Then
  ' pas de bol, on n'arrive pas a avoir de fichier temporaire !
    GetTemporaryFileName = ""
    Exit Function
  End If
  sfName = stripNullChars(sfName)
  sfName = GetActualLongFileName(sfName)
  If (sFormerTmpName <> "") Then
    If FileExists(sFormerTmpName) Then
      KillOrAtLeastErase sFormerTmpName
    End If
  End If
  sFormerTmpName = sfName
  If (Len(sSuffix) = 0) Then
    boFoundTempFile = True
    sResult = sfName
  Else
' sSuffix <> "" : remplacer l'extension systeme par l'extension demandee
    GetFileNameExtension sfName, sResult, sfExt
    If (Left(sSuffix, 1) = ".") Then
      sResult = sResult & sSuffix
    Else
      sResult = sResult & "." & sSuffix
    End If
    If (Not FileExists(sResult)) Then
      boFoundTempFile = True
      Name sfName As sResult
    Else
' Just loop!
    End If
  End If
Loop

If boFoundTempFile Then
  KillOrAtLeastErase sResult
  GetTemporaryFileName = sResult
Else
  GetTemporaryFileName = ""
End If

End Function


'
' ****************************************************
' ***** Obtenir le vrai nom complet d'un fichier *****
' ****************************************************
Public Function GetActualLongFileName(dosName As String) As String
Dim hFind As Long ' le handle pour FindFirstFile et FindNextFile
Dim fileData As WIN32_FIND_DATA
Dim fn As String, fp As String
Dim nameEndsBySep As Boolean
Dim s As String, sep As String, resultName As String
Dim lgrDosName As Long, pos As Long, start As Long
Dim names() As String, numNames As Long, i As Long

' following line used at Debug time only - MUST be left commented
' dosName = Left$(dosName, Len(dosName) - 1)

lgrDosName = Len(dosName)
If lgrDosName < 3 Then
  GetActualLongFileName = dosName ' bizarre => on ne touche a rien !
  Exit Function
End If

sep = "\"
If Right$(dosName, 1) = sep Then
  nameEndsBySep = True
  s = dosName
Else
  nameEndsBySep = False
  s = dosName & sep ' ajouter un separateur de fin de boucle
End If

If Mid(s, 2, 1) = ":" Then
  pos = InStr(2, s, sep, vbTextCompare) ' cas normal d'un drive
ElseIf Mid(s, 1, 2) = "\\" Then
  pos = InStr(3, s, sep, vbTextCompare) ' cas normal d'un drive
Else
  GetActualLongFileName = dosName ' bizarre => on ne touche a rien !
  Exit Function
End If

start = 0 ' NB : on garde le debut du nom dans le 1er item
While pos < lgrDosName
  pos = InStr(pos + 1, s, sep, vbTextCompare)
  numNames = numNames + 1
  ReDim Preserve names(1 To numNames)
  names(numNames) = Mid(s, start + 1, pos - start - 1)
  start = pos
Wend

resultName = "": s = ""
For i = 1 To numNames
  s = resultName & names(i)
' utilisation de FindFirstFile pour trouver le nom long du fichier
' FindFirstFile  ne rend que le nom, pas le path
  ExtractFileNameAndPath s, fn, fp
  hFind = FindFirstFile(s, fileData)
  Call FindClose(hFind)
  If fp = "" Then
    resultName = stripNullChars(fileData.cFileName)
  Else
    resultName = fp & sep & stripNullChars(fileData.cFileName)
  End If
  If i < numNames Then
    resultName = resultName & sep
  End If
Next i

' completer si necessaire par appel a GetFullPathName()
' on ne change resultName que si la fonction GetFullPathName() "reussit"
s = "": i = 0: fn = ""
i = GetFullPathName(resultName, i, s, fn) ' obtenir la longueur necessaire
If i > 0 Then
  s = Space(i): fn = Space(i)
  i = GetFullPathName(resultName, i, s, fn)
  If i > 0 Then
    resultName = Left(s, i)  ' enlever le '\0'
  End If
End If

If nameEndsBySep Then resultName = resultName & sep
GetActualLongFileName = resultName
End Function


' Recherche de l'executable associe a une extension de fichier donnee
' on cree un fichier temporaire avec l'extension cherchee, puis on
' appelle FindExecutable() pour trouver l'opener
' Enfin on efface le fichier temporaire
Public Function FindFileOpener(sExtension As String) As String
Dim tempDir As String, tempLgr As Long
Dim sfName As String, extensFile As String, sfPath As String, sWork As String
Dim hInstance As Long

' rechercher notre repertoire des fichiers temporaires
tempDir = "": tempLgr = 0
tempLgr = GetTempPath(tempLgr, tempDir) ' obtenir la longueur necessaire
If (tempLgr > 0) Then
  tempDir = Space(tempLgr)
  tempLgr = GetTempPath(tempLgr, tempDir) ' obtenir la vraie valeur
End If

If (tempLgr <= 0) Then
  FindFileOpener = ""
  Exit Function
End If
tempDir = Left(tempDir, tempLgr)  ' enlever le '\0' final
' Obtenir le nom "long" du repertoire TEMP
tempDir = GetActualLongFileName(tempDir)

sfName = Space$(MAX_PATH)
If (GetTempFileName(tempDir, "pat", 0, sfName) = 0) Then
  FindFileOpener = ""
  Exit Function
End If

' remplacer l'extension ".tmp" par ".pdf"
sfName = GetActualLongFileName(stripNullChars(sfName))
GetFileNameExtension sfName, extensFile, sfPath
' changer le nom
If (StrComp(sExtension, "tmp", vbTextCompare) <> 0) Then
  extensFile = extensFile & "." & sExtension
  KillOrAtLeastErase extensFile
  Name sfName As extensFile
End If

' Le fichier temporaire est cree - on peut enfin chercher l'ouvre-boite !
sWork = Space$(MAX_PATH)
hInstance = FindExecutable(extensFile, sfPath, sWork)
If (hInstance > 32) Then
' La fonction FindExecutable() dit OK en rendant une valeur > 32 (sic!)
' Il faut chercher le '\0' (fonction C...) et tronquer le resultat a ce point
  hInstance = LookUpForSeparator(sWork, Chr$(0), 1)
  If (hInstance > 0) Then
    sWork = Left(sWork, (hInstance - 1))
  End If
Else
  sWork = ""
End If
KillOrAtLeastErase extensFile
FindFileOpener = sWork
End Function


